<?php

namespace Project\Bundle\ProjectBundle\Entity;

use Akeneo\Pim\Structure\Component\Model\Family as AkeneoFamily;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Induxx\Bundle\EasyCatalogBundle\Entity\FamilyAttributePrint;

/**
 * Class Family
 * @package Project\Bundle\ProjectBundle\Entity
 */
class Family extends AkeneoFamily
{
    /** @var Collection */
    protected $attributesPrint;

    /**
     * Constructor
     */
    public function __construct()
    {
        parent::__construct();

        $this->attributesPrint = new ArrayCollection();
    }

    /**
     * {@inheritdoc}
     */
    public function addAttributePrint(FamilyAttributePrint $attributePrint)
    {
        $attributePrintKey = $this->getAttributePrintKey($attributePrint);
        $attributesPrint = $this->getattributesPrint();

        if (!isset($attributesPrint[$attributePrintKey])) {
            $attributePrint->setFamily($this);
            $this->attributesPrint->add($attributePrint);
        } else {
            $attributesPrint[$attributePrintKey]->setSortOrder($attributePrint->getSortOrder());
            $attributesPrint[$attributePrintKey]->setIsModel($attributePrint->isModel());
            $attributesPrint[$attributePrintKey]->setIsVariant($attributePrint->isVariant());
        }

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function removeAttributePrint(FamilyAttributePrint $attributePrint)
    {
        $this->attributesPrint->removeElement($attributePrint);

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function setattributesPrint(array $attributesPrint)
    {
        foreach ($attributesPrint as $attributePrint) {
            $attributePrint->setFamily($this);
        }

        $this->attributesPrint = new ArrayCollection($attributesPrint);

        return $this;
    }

    /**
     * @return array
     */
    public function getattributesPrint()
    {
        $result = [];

        foreach ($this->attributesPrint as $attributePrint) {
            $key = $this->getAttributePrintKey($attributePrint);
            $result[$key] = $attributePrint;
        }

        return $result;
    }

    /**
    * {@inheritdoc}
    */
    public function getAttributePrintKey(FamilyAttributePrint $attributePrint)
    {
        return $attributePrint->getAttributeCode();
    }
}
